#include "setColor.h"
#include "getFilePath.h"

#include <stdio.h>
#include <string.h>

#define CONFIG_PATH_LEN 512
#define CONFIG_LINE_LEN 40

void printExample(void);
void printOneColorExample(int numColor, int linkColor, int textColor,
        int num, char *text, int preBlankNum, int lastEnter, int maxTextLen);

void setColor(void)
{
    FILE *fp;
    FILE *fp_swp;
    char configPath[CONFIG_PATH_LEN];
    char configSwpPath[CONFIG_PATH_LEN];
    char line[CONFIG_LINE_LEN];
    char colorMode;

    putchar('\n');
    printExample();
    putchar('\n');

    printf("请输入你要设置的颜色类型，默认0：\n");
    scanf("%c", &colorMode);
    if ((colorMode >= '0' && colorMode <= '6')
            || (colorMode >= 'a' && colorMode <= 'm')) {
        getConfigPath(configPath);
        fp = fopen(configPath, "r");
        getConfigSwpPath(configSwpPath);
        fp_swp = fopen(configSwpPath, "w");
        while (fgets(line, CONFIG_LINE_LEN, fp) != NULL) {
            if (strncmp(line, "set color ", 10) == 0)
                line[10] = colorMode;
            fputs(line, fp_swp);
        }
        fclose(fp);
        fclose(fp_swp);
        remove(configPath);
        rename(configSwpPath, configPath);
    }
    else {
        printf("没有此颜色类型\n");
        return;
    }
}

void printExample(void)
{
    printOneColorExample(0, 0, 0, '0', "lyre", 1, 0, 10);
    printOneColorExample(0, 33, 0, 'a', "sun", 12, 1, 10);

    printOneColorExample(31, 0, 31, '1', "chess", 1, 0, 10);
    printOneColorExample(31, 34, 0, 'b', "moon", 12, 1, 10);

    printOneColorExample(32, 0, 32, '2', "book", 1, 0, 10);
    printOneColorExample(32, 34, 0, 'c', "gold", 12, 1, 10);

    printOneColorExample(33, 0, 33, '3', "picture", 1, 0, 10);
    printOneColorExample(33, 34, 0, 'd', "wood", 12, 1, 10);

    printOneColorExample(34, 0, 34, '4', "poem", 1, 0, 10);
    printOneColorExample(34, 33, 0, 'e', "water", 12, 1, 10);

    printOneColorExample(35, 0, 35, '5', "wine", 1, 0, 10);
    printOneColorExample(35, 34, 0, 'f', "fire", 12, 1, 10);

    printOneColorExample(36, 0, 36, '6', "tea", 1, 0, 10);
    printOneColorExample(36, 34, 0, 'g', "soil", 12, 1, 10);

    putchar('\n');

    printOneColorExample(32, 34, 33, 'h', "spring", 1, 1, 10);
    printOneColorExample(33, 35, 32, 'i', "summer", 1, 1, 10);
    printOneColorExample(36, 35, 33, 'j', "autumn", 1, 1, 10);
    printOneColorExample(33, 34, 36, 'k', "winter", 1, 1, 10);
    printOneColorExample(32, 35, 36, 'l', "day", 1, 1, 10);
    printOneColorExample(36, 34, 32, 'm', "night", 1, 1, 10);
}

void printOneColorExample(int numColor, int linkColor, int textColor,
        int num, char *text, int preBlankNum, int lastEnter, int maxTextLen)
{
    /* print blanks before number */
    while (--preBlankNum >= 0)
        putchar(' ');
    /* print number */
    if (numColor == 0)
        printf("%c", num);
    else
        printf("\033[01;%dm%c\033[00m", numColor, num);
    /* print - */
    if (linkColor == 0)
        printf(" - ");
    else
        printf(" \033[01;%dm-\033[00m ", linkColor);
    /* print text */
    if (textColor == 0)
        printf("%s", text);
    else
        printf("\033[01;%dm%s\033[00m", textColor, text);
    /* print <- color[] */
    maxTextLen -= strlen(text);
    while (--maxTextLen >= 0)
        putchar(' ');
    printf("<- color[%c]", num);
    /* print enter(s) */
    while (--lastEnter >= 0)
        putchar('\n');
}
